import com.nerius.math.geom.*;
import com.nerius.math.xform.*;

public final class PipeGenerator {

  public static void main(String[] args) {
    final int radius = Integer.parseInt(args[0]);
    // Should be even.
    final int slicesQuarter = Integer.parseInt(args[1]);
    final int thickness = Integer.parseInt(args[2]);
    final int width = Integer.parseInt(args[3]);
    final Point3D[][] mesh = new Point3D[slicesQuarter / 2 + 1][2];
    mesh[0][0] = new Point3D(radius, 0, 0);
    mesh[0][1] = new Point3D(radius, width, 0);
    final double sliceAngle = (Math.PI / 2) / slicesQuarter;
    for (int i = 1; i <= slicesQuarter / 2; i++) {
      final AxisRotation3D rot = new AxisRotation3D
        (AxisRotation3D.Y_AXIS, sliceAngle * i);
      mesh[i][0] = rot.transform(mesh[0][0]);
      mesh[i][1] = rot.transform(mesh[0][1]);
    }
    startMap();
    for (int i = 0; i < slicesQuarter / 2; i++) {
      startBrush();
      writeFace(mesh[i][0],
                mesh[i + 1][0],
                mesh[i][1]);
      writeFace(mesh[i][0],
                mesh[i][1],
                new Point3D(radius + thickness,
                            mesh[i][0].y,
                            mesh[i][0].z));
      writeFace(mesh[i][0],
                new Point3D(radius + thickness,
                            mesh[i][0].y,
                            mesh[i][0].z),
                mesh[i + 1][0]);
      writeFace(mesh[i + 1][0],
                new Point3D(radius + thickness,
                            mesh[i + 1][0].y,
                            mesh[i + 1][0].z),
                mesh[i + 1][1]);
      writeFace(mesh[i][1],
                mesh[i + 1][1],
                new Point3D(radius + thickness,
                            mesh[i][1].y,
                            mesh[i][1].z));
      writeFace(new Point3D(radius + thickness,
                            mesh[i][1].y,
                            mesh[i][1].z),
                new Point3D(radius + thickness,
                            mesh[i + 1][1].y,
                            mesh[i + 1][1].z),
                new Point3D(radius + thickness,
                            mesh[i][0].y,
                            mesh[i][0].z));
      endBrush();
    }
    endMap();
  }

  private static void startMap() {
    System.out.println("{");
    System.out.println("\"classname\" \"worldspawn\"");
  }

  private static void endMap() {
    System.out.println("}");
  }

  private static void startBrush() {
    System.out.println("{");
  }

  private static void endBrush() {
    System.out.println("}");
  }

  private static void writeFace(final Point3D pt1,
                                final Point3D pt2,
                                final Point3D pt3) {
    writePoint(pt1);
    System.out.print(" ");
    writePoint(pt2);
    System.out.print(" ");
    writePoint(pt3);
    System.out.println
      (" radiant/notex 0 0 0 0.500000 0.500000 0 0 0");
  }

  private static void writePoint(final Point3D pt) {
    System.out.print("( " + Math.round(pt.x) + " " + Math.round(pt.y) + " " +
                     Math.round(pt.z) + " )");
  }

}
